#this is reportlab/rl_config.py
def _startUp():
    pass    #normally we would initialize all the rl_config.attributes here

_registered_resets=[]
def register_reset(func):
    '''register a function to be called by rl_config._reset'''
    _registered_resets[:] = [x for x in _registered_resets if x()]
    L = [x for x in _registered_resets if x() is func]
    if L: return
    from weakref import ref
    _registered_resets.append(ref(func))

def _reset():
    '''attempt to reset reportlab and friends'''
    _startUp()  #our reset
    for f in _registered_resets[:]:
        c = f()
        if c:
            c()
        else:
            _registered_resets.remove(f)

_startUp()

#this is reportlab/lib/sequencer.py
class Sequencer:

    def __init__(self):
        self._counters = {}  #map key to current number
        self._formatters = {}
        self._reset()

    def _reset(self):
        self._counters.clear()
        self._formatters.clear()
        self._formatters.update({
            # the formats it knows initially
            '1':1,
            'A':2,
            'a':3,
            'I':4,
            'i':5,
            })
        d = dict(_counters=self._counters,_formatters=self._formatters)
        self.__dict__.clear()
        self.__dict__.update(d)
        self._defaultCounter = None

"""Your story builder needs to set this to"""
_sequencer = None

def getSequencer():
    global _sequencer
    if _sequencer is None:
        _sequencer = Sequencer()
    return  _sequencer

def _reset():
    global _sequencer
    if _sequencer:
        _sequencer._reset()

register_reset(_reset)

#this is our test
if __name__=='__main__':
    seq = getSequencer()
    seq._dingo = 1
    _reset()
    assert not hasattr(seq,'_dingo')
    print('OK')
